'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.concat = exports.flow = undefined;

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

exports.revertChange = revertChange;

var _types = require('./types');

var _lodash = require('lodash.flow');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.concat');

var _lodash4 = _interopRequireDefault(_lodash3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.flow = _lodash2.default;

// Lodash utils

exports.concat = _lodash4.default;

// Take a change event and revert it

function revertChange(change) {
  var obs = change.object;
  if (change.type === 'update') {
    var newChange = {
      object: change.object,
      type: 'update',
      name: change.name,
      index: change.index,
      oldValue: null
    };

    if (change.index !== undefined) {
      // Array
      newChange.oldValue = obs[change.index];
      obs[change.index] = change.oldValue;
    } else if (obs.constructor.name === 'ObservableMap') {
      // MobX Map
      newChange.oldValue = obs.get(change.name);
      obs.set(change.name, change.oldValue);
    } else {
      // MobX Object
      newChange.oldValue = obs[change.name];
      obs[change.name] = change.oldValue;
    }

    return newChange;
  }
  var removed = obs.splice.apply(obs, [change.index, change.addedCount].concat((0, _toConsumableArray3.default)(change.removed)));
  return {
    object: change.object,
    type: 'splice',
    removed: removed,
    index: change.index,
    addedCount: change.removed.length
  };
}